> For the complete documentation index, see [llms.txt](https://docs.kubemq.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.kubemq.io/configuration/connectors/kubemq-bridges/sources/query.md).

# Query

KubeMQ Bridges Query source provides an RPC query subscriber for processing target commands.

## Prerequisites

The following are required to run the query source connector:

* kubemq cluster
* kubemq-bridges deployment

## Configuration

Query source connector configuration properties:

| Properties Key               | Required | Description                            | Example                                              |
| ---------------------------- | -------- | -------------------------------------- | ---------------------------------------------------- |
| address                      | yes      | kubemq server address (gRPC interface) | kubemq-cluster-a-grpc.kubemq.svc.cluster.local:50000 |
| client\_id                   | no       | set client id                          | "client\_id"                                         |
| auth\_token                  | no       | set authentication token               | JWT token                                            |
| channel                      | yes      | set channel to subscribe               |                                                      |
| group                        | no       | set subscriber group                   |                                                      |
| auto\_reconnect              | no       | set auto reconnect on lost connection  | "false", "true"                                      |
| reconnect\_interval\_seconds | no       | set reconnection seconds               | "5"                                                  |
| max\_reconnects              | no       | set how many time to reconnect         | "0"                                                  |

Example:

```yaml
bindings:
  - name:  query-binding 
    properties: 
      log_level: error
      retry_attempts: 3
      retry_delay_milliseconds: 1000
      retry_max_jitter_milliseconds: 100
      retry_delay_type: "back-off"
      rate_per_second: 100
    sources:
      kind: source.query # Sources kind
      name: 3-clusters-source # sources name 
      connections: # Array of connections settings per each source kind
        - address: "kubemq-cluster-a-grpc.kubemq.svc.cluster.local:50000"
          client_id: "cluster-a-query-connection"
          auth_token: ""
          channel: "query"
          group: ""
        - address: "kubemq-cluster-b-grpc.kubemq.svc.cluster.local:50000"
          client_id: "cluster-b-query-connection"
          auth_token: ""
          channel: "query"
          group: ""
        - address: "kubemq-cluster-c-grpc.kubemq.svc.cluster.local:50000"
          client_id: "cluster-c-query-connection"
          auth_token: ""
          channel: "query"
          group: ""              
    targets:
    .....
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.kubemq.io/configuration/connectors/kubemq-bridges/sources/query.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
